#
# spec file for package gcc5-testresults
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#
# icecream 0


%define building_testsuite 1
%define run_tests 1
#
# spec file for package gcc5
#
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# Ada currently fails to build on a few platforms, enable it only
# on those that work
%if %{suse_version} >= 1310
%define ada_arch %ix86 x86_64 ppc ppc64 s390 ia64
%else
%define ada_arch %ix86 x86_64 ppc s390 ia64
%endif

%ifarch %ada_arch
%define build_ada !0%{?building_libjava:1}%{?building_libffi:1}
%else
%define build_ada 0
%endif

%define quadmath_arch %ix86 x86_64 ia64
%define tsan_arch x86_64
%define asan_arch x86_64 %ix86 ppc ppc64 ppc64le %sparc %arm aarch64
%define itm_arch x86_64 %ix86 %arm aarch64 ppc ppc64 ppc64le s390 s390x %sparc
%define atomic_arch x86_64 %ix86 %arm aarch64 ppc ppc64 ppc64le s390 s390x %sparc m68k ia64
%define lsan_arch x86_64
%define ubsan_arch x86_64 %ix86 ppc ppc64 ppc64le %arm aarch64
%if 0%{?build_libvtv:1}
%define vtv_arch x86_64 %ix86
%endif
%define cilkrts_arch x86_64 %ix86
%if %{suse_version} >= 1310
%define mpx_arch x86_64 %ix86
%endif

# We don't want to build java
%ifarch mips
%define build_java 0
%define build_libjava 0
%else
%define build_java 1
%define build_libjava 0%{?building_libjava:1}%{?building_libffi:1}%{?building_testsuite:1}
%endif

%define build_cp 1
%define build_fortran !0%{?building_libjava:1}%{?building_libffi:1}
%define build_objc !0%{?building_libjava:1}%{?building_libffi:1}
%define build_objcp !0%{?building_libjava:1}%{?building_libffi:1}
%define build_go !0%{?building_libjava:1}%{?building_libffi:1}

%if %{build_objcp}
%define build_cp 1
%define build_objc 1
%endif

%if %{build_libjava}
%define build_cp 1
%endif

# For optional compilers only build C, C++, Fortran, Ada and Go
%if 0%{?build_optional_compiler_languages:1}
%define build_java 0
%define build_libjava 0
%define build_objc 0
%define build_objcp 0
%endif

# Shared library SONAME versions
%ifarch hppa
%define libgcc_s 4
%else
%ifarch m68k
%define libgcc_s 2
%else
%define libgcc_s 1
%endif
%endif
%define libgcj_sover 16
%define libgcj_bc_sover 1
%define libffi_sover 4
%define libgomp_sover 1
%define libstdcxx_sover 6
%define libobjc_sover 4
%define libgfortran_sover 3
%define libquadmath_sover 0
%define libasan_sover 2
%define libtsan_sover 0
%define libatomic_sover 1
%define libitm_sover 1
%define libubsan_sover 0
%define liblsan_sover 0
%define libvtv_sover 0
%define libcilkrts_sover 5
%define libgo_sover 7
%define libmpx_sover 0
%define libmpxwrappers_sover 0

# Shared library package suffix
# This is used for the "non-standard" set of libraries, the standard
# being defined by %product_libs_gcc_ver, the GCC version that should
# provide un-suffixed shared library packages following the shared-library
# policy.  Even suffixed variants should provide the shared-library policy
# mandated names and ensure they conflict with each other.
# Individual shared libraries can be directed to be built from individual
# gcc versions by defining %product_libs_gcc_ver_libgcc_s1 for example,
# generally %product_libs_gcc_ver_%name%sover, similarly.

%define itsme5 1
%define plv_ %{!?product_libs_gcc_ver:5}%{?product_libs_gcc_ver}
%define plv() %{expand:%%{!?itsme%{expand:%%{!?product_libs_gcc_ver_%{1}%{2}:%%{plv_}}%%{?product_libs_gcc_ver_%{1}%{2}}}:-gcc5}}

%define libgcc_s_suffix %{plv libgcc_s %{libgcc_s}}
# libgcj SONAME changes with every GCC version
%define libgcj_suffix %nil
%define libgcj_bc_suffix %{plv libgcj_bc %{libgcj_bc_sover}}
%define libffi_suffix %{plv libffi %{libffi_sover}}
%define libgomp_suffix %{plv libgomp %{libgomp_sover}}
%define libstdcxx_suffix %{plv libstdcxx %{libstdcxx_sover}}
%define libobjc_suffix %{plv libobjc %{libobjc_sover}}
%define libgfortran_suffix %{plv libgfortran %{libgfortran_sover}}
%define libquadmath_suffix %{plv libquadmath %{libquadmath_sover}}
%define libasan_suffix %{plv libasan %{libasan_sover}}
%define libtsan_suffix %{plv libtsan %{libtsan_sover}}
%define libatomic_suffix %{plv libatomic %{libatomic_sover}}
%define libitm_suffix %{plv libitm %{libitm_sover}}
%define libubsan_suffix %{plv libubsan %{libubsan_sover}}
%define liblsan_suffix %{plv liblsan %{liblsan_sover}}
%define libvtv_suffix %{plv libvtv %{libvtv_sover}}
%define libcilkrts_suffix %{plv libcilkrts %{libcilkrts_sover}}
%define libgo_suffix %{plv libgo %{libgo_sover}}
%define libmpx_suffix %{plv libmpx %{libmpx_sover}}
%define libmpxwrappers_suffix %{plv libmpxwrappers %{libmpx_sover}}

# libFOO-devel package suffix
%define libdevel_suffix -gcc5

%if %{suse_version} >= 1220
%define selfconflict() %1
%else
%define selfconflict() otherproviders(%1)
%endif

Name:           gcc5-testresults
# With generated files in src we could drop the following
BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  gettext-devel
%if %{suse_version} > 1220
BuildRequires:  makeinfo
%else
BuildRequires:  texinfo
%endif
# until here, but at least renaming and patching info files breaks this
BuildRequires:  gcc-c++
BuildRequires:  glibc-devel-32bit glibc-32bit
BuildRequires:  mpc-devel
BuildRequires:  mpfr-devel
BuildRequires:  perl
BuildRequires:  zlib-devel
%if %{suse_version} >= 1230
BuildRequires:  isl-devel
%endif
%if %{build_ada}
%if %{suse_version} > 1330
%define hostsuffix %{binsuffix}
BuildRequires:  gcc5-ada
%else
%define hostsuffix %{nil}
BuildRequires:  gcc-ada
%endif
%endif
%if 0%{?building_libjava:1}%{?building_testsuite:1}
BuildRequires:  fastjar
# For building the libstdc++ API reference
BuildRequires:  doxygen
BuildRequires:  graphviz
%endif
%if 0%{?building_libffi:1}
BuildRequires:  pkg-config
%endif
%ifarch ia64
BuildRequires:  libunwind-devel
%endif
%if 0%{?run_tests:1}
BuildRequires:  dejagnu
BuildRequires:  expect
BuildRequires:  gdb
%endif

%define separate_bi32 0
%define separate_bi64 0
%ifarch ppc sparcv9
# Beware, this does _not_ separate libgcj, as for that one multilibing
# is inactive for the time being
%define separate_bi64 1
%endif
%ifarch x86_64 s390x ppc64 sparc64
%define separate_bi32 1
%endif

# Define two macros to trigger -32bit or -64bit package variants
%define separate_biarch 0
%if %{separate_bi32}
%define separate_biarch 1
%define separate_biarch_suffix -32bit
%endif
%if %{separate_bi64}
%define separate_biarch 1
%define separate_biarch_suffix -64bit
%endif

%ifarch x86_64 ia64 s390x alpha ppc64 sparc64
# 64-bit is primary build target
%define build_primary_64bit 1
%else
%define build_primary_64bit 0
%endif

%define biarch_libjava 0

%define biarch_targets x86_64 s390x powerpc64 powerpc sparc sparc64

Url:            http://gcc.gnu.org/
Version:        5.3.1+r233831
Release:        10.3
%define gcc_version %(echo %version | sed 's/+.*//')
%define gcc_dir_version %(echo %gcc_version | cut -d '.' -f 1)
%define gcc_snapshot_revision %(echo %version | sed 's/[3-9]\.[0-9]\.[0-6]//' | sed 's/+/-/')
%define binsuffix -5

%if !0%{?building_libjava:1}%{?building_libffi:1}%{?building_testsuite:1}
Requires:       binutils
Requires:       cpp5 = %{version}-%{release}
Requires:       glibc-devel
Requires:       libgcc_s%{libgcc_s} >= %{version}-%{release}
Requires:       libgomp%{libgomp_sover} >= %{version}-%{release}
%ifarch %asan_arch
Requires:       libasan%{libasan_sover} >= %{version}-%{release}
%endif
%ifarch %tsan_arch
Requires:       libtsan%{libtsan_sover} >= %{version}-%{release}
%endif
%ifarch %atomic_arch
Requires:       libatomic%{libatomic_sover} >= %{version}-%{release}
%endif
%ifarch %itm_arch
Requires:       libitm%{libitm_sover} >= %{version}-%{release}
%endif
%ifarch %cilkrts_arch
Requires:       libcilkrts%{libcilkrts_sover} >= %{version}-%{release}
%endif
%ifarch %lsan_arch
Requires:       liblsan%{liblsan_sover} >= %{version}-%{release}
%endif
%ifarch %ubsan_arch
Requires:       libubsan%{libubsan_sover} >= %{version}-%{release}
%endif
%ifarch %vtv_arch
Requires:       libvtv%{libvtv_sover} >= %{version}-%{release}
%endif
%ifarch %mpx_arch
Requires:       libmpx%{libmpx_sover} >= %{version}-%{release}
Requires:       libmpxwrappers%{libmpxwrappers_sover} >= %{version}-%{release}
%endif
Suggests:       gcc5-info gcc5-locale
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source:         gcc-%{gcc_version}%{gcc_snapshot_revision}.tar.bz2
Source1:        change_spec
Source2:        libffi-gcc5-rpmlintrc
Source3:        gcc5-rpmlintrc
Source4:        ecj.jar
Source5:        README.First-for.SuSE.packagers
Source6:        baselibs.conf
Source7:        libgcj-gcc5-rpmlintrc

#testpatch begin

Patch1:         gcc-dir-version.patch
Patch2:         gcc-add-defaultsspec.diff
Patch3:         Wunprototyped-calls.diff
Patch4:         libjava-no-multilib.diff
Patch5:         tls-no-direct.diff
Patch6:         gcc43-no-unwind-tables.diff
Patch7:         gcc48-libstdc++-api-reference.patch
Patch8:         gcc5-libsanitize-aarch64-va42.patch
Patch9:         gcc48-remove-mpfr-2.4.0-requirement.patch
Patch10:        gcc5-no-return-gcc43-workaround.patch
Patch11:        gcc5-aarch64-libffi.patch
# A set of patches from the RH srpm
Patch50:        gcc41-java-slow_pthread_self.patch
Patch51:        gcc41-ppc32-retaddr.patch
# Some patches taken from Debian
Patch60:        gcc44-textdomain.patch
Patch61:        gcc44-rename-info-files.patch
# Some libgo patches
Patch70:        gcc5-libgo-fix-certificates-lookup.patch

#testpatch end

Summary:        Testsuite results
License:        SUSE-Public-Domain
Group:          Development/Languages/C and C++

%description 
Results from running the gcc and target library testsuites.




# Define the canonical target and host architecture
#   %gcc_target_arch  is supposed to be the full target triple
#   %cross_arch       is supposed to be the rpm target variant arch
#   %TARGET_ARCH      will be the canonicalized target CPU part
#   %HOST_ARCH        will be the canonicalized host CPU part
%if 0%{?gcc_target_arch:1}
%define TARGET_ARCH %(echo %{cross_arch} | sed -e "s/i.86/i586/;s/ppc/powerpc/;s/sparc64.*/sparc64/;s/sparcv.*/sparc/;")
%else
%define TARGET_ARCH %(echo %{_target_cpu} | sed -e "s/i.86/i586/;s/ppc/powerpc/;s/sparc64.*/sparc64/;s/sparcv.*/sparc/;")
%endif
%define biarch %(case " %{biarch_targets} " in (*" %{TARGET_ARCH} "*) echo 1;; (*) echo 0;; esac)

%define HOST_ARCH %(echo %{_host_cpu} | sed -e "s/i.86/i586/;s/ppc/powerpc/;s/sparc64.*/sparc64/;s/sparcv.*/sparc/;")
%ifarch ppc
%define GCCDIST powerpc64-suse-linux
%else
%ifarch %sparc
%define GCCDIST sparc64-suse-linux
%else
%ifarch %arm
%define GCCDIST %{HOST_ARCH}-suse-linux-gnueabi
%else
%define GCCDIST %{HOST_ARCH}-suse-linux
%endif
%endif
%endif

%define libsubdir %{_libdir}/gcc/%{GCCDIST}/%{gcc_dir_version}
%define gxxinclude %{_prefix}/include/c++/%{gcc_dir_version}

# Versionspecific directories
%define versmainlibdir %{libsubdir}
%define versmainlibdirbi32 %{libsubdir}/32
%define versmainlibdirbi64 %{libsubdir}/64
%ifarch ppc
%define versmainlibdirbi32 %{libsubdir}
%define versmainlibdirbi64 %{libsubdir}/64
%endif
%if %{build_primary_64bit}
%define versmainlibdirbi %{versmainlibdirbi32}
%else
%define versmainlibdirbi %{versmainlibdirbi64}
%endif

%define mainlibdir %{_libdir}
%define mainlibdirbi32 %{_prefix}/lib
%define mainlibdirbi64 %{_prefix}/lib64
%if %{build_primary_64bit}
%define mainlibdirbi %{mainlibdirbi32}
%else
%define mainlibdirbi %{mainlibdirbi64}
%endif

# Now define a few macros that make it easy to package libs and
# related files just to the right package, without caring for the
# exact path the files are in.
#   %mainlib  package X from all dirs that belong to the main package
#   %biarchlib   package X from all dirs that belong to the -32/64bit package
%define mainlib() %{mainlibdir}/%1\
%{nil}
%define biarchlib() %{nil}
%if %{biarch}
%if !%{separate_biarch}
%define mainlib() %{mainlibdir}/%1\
%{mainlibdirbi}/%1\
%{nil}
%else
%define biarchlib() %{mainlibdirbi}/%1\
%{nil}
%endif
%endif

%define versmainlib() %{versmainlibdir}/%1\
%{nil}
%define versbiarchlib() %{nil}
%if %{biarch}
%if !%{separate_biarch}
%define versmainlib() %{versmainlibdir}/%1\
%{versmainlibdirbi}/%1\
%{nil}
%else
%define versbiarchlib() %{versmainlibdirbi}/%1\
%{nil}
%endif
%endif

%prep
%setup -q -n gcc-%{gcc_version}%{gcc_snapshot_revision}

#test patching start

%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
%if %{suse_version} < 1310
%patch9
%endif
%patch10
%if %{suse_version} <= 1320
%patch11
%endif
%patch50
%patch51
%patch60
%patch61
%patch70

#test patching end

# We are configuring ppc as ppc64 but with switched multilibs.  Adjust
# the libstdc++ abi testsuite baseline files accordingly
%ifarch ppc
if [ -d libstdc++-v3/config/abi/post/powerpc64-linux-gnu ]; then
  mkdir -p libstdc++-v3/config/abi/post/powerpc64-linux-gnu/64
  mv libstdc++-v3/config/abi/post/powerpc64-linux-gnu/baseline_symbols.txt \
	libstdc++-v3/config/abi/post/powerpc64-linux-gnu/64/
  mv libstdc++-v3/config/abi/post/powerpc64-linux-gnu/32/baseline_symbols.txt \
	libstdc++-v3/config/abi/post/powerpc64-linux-gnu/
fi
%endif

%build
# Avoid rebuilding of generated files
contrib/gcc_update --touch
# Avoid fucking up testsuite results with Java and indirect dispatch
export SUSE_ASNEEDED=0
# Split version file into version used for directories (X) and
# version to report with --version (X.Y.Z).
# See also gcc-dir-version.patch.
mv gcc/BASE-VER gcc/FULL-VER
cat gcc/FULL-VER | cut -d '.' -f 1 > gcc/BASE-VER

# SLE11 does not allow empty rpms
%if %{suse_version} < 1310
echo "This is a dummy package to provide a dependency." > README
%endif

rm -rf obj-%{GCCDIST}
mkdir obj-%{GCCDIST}
cd obj-%{GCCDIST}
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -U_FORTIFY_SOURCE"
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g' -e 's/-Wmissing-format-attribute//g' -e 's/-fstack-protector[^ ]*//g' -e 's/-ffortify=.//g' -e 's/-Wall//g' -e 's/-m32//g' -e 's/-m64//g'`
%ifarch %ix86
# -mcpu is superceded by -mtune but -mtune is not supported by
# our bootstrap compiler.  -mcpu gives a warning that stops
# the build process, so remove it for now.  Also remove all other
# -march and -mtune flags.  They are superseeded by proper
# default compiler settings now.
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-mcpu=i.86//g' -e 's/-march=i.86//g' -e 's/-mtune=i.86//g'`
%endif
%ifarch s390 s390x
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fsigned-char//g'`
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-O1/-O2/g'`
%endif
%if 0%{?gcc_target_arch:1}
# Kill all -march/tune/cpu because that screws building the target libs
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-m\(arch\|tune\|cpu\)=[^ ]*//g'`
%endif
# Replace 2 spaces by one finally
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/  / /g'`

languages=c
%if %{build_cp}
languages=$languages,c++
%endif
%if %{build_objc}
languages=$languages,objc
%endif
%if %{build_fortran}
languages=$languages,fortran
%endif
%if %{build_objcp}
languages=$languages,obj-c++
%endif
%if %{build_java}
languages=$languages,java
%endif
%if %{build_ada}
languages=$languages,ada
%endif
%if %{build_go}
languages=$languages,go
%endif

J=%{?jobs:%jobs}
if test -z "$J"; then
  J=$(getconf _NPROCESSORS_CONF)
  JL=$(($J * 2))
else
  test 1 -gt "$J" && J=1
  JL=$(($(getconf _NPROCESSORS_CONF)*2))
fi
if test "$J" == "0"; then
  J=1
fi
if test "$JL" == "0"; then
  JL=1
fi
PARALLEL="-j$J -l$JL"

# we don't want some miscompiles in the testsuite, or some fault in
# the compiler to kill the machine.  Hence we limit the amount of memory
# by the physical RAM plus half of swap
#MEM=$(free -m | awk '/^Mem:/ {print $2}')
#SWAP=$(free -m | awk '/^Swap:/ {print $2}')
#ulimit -v $(((MEM + SWAP/2)*1024))

# In general we want to ship release checking enabled compilers
# which is the default for released compilers
#ENABLE_CHECKING="--enable-checking=yes"
ENABLE_CHECKING="--enable-checking=release"
#ENABLE_CHECKING=""

# Work around tail/head -1 changes
export _POSIX2_VERSION=199209

%if %{build_ada}
# Using the host gnatmake like
#   CC="gcc%{hostsuffix}" GNATBIND="gnatbind%{hostsuffix}"
#   GNATMAKE="gnatmake%{hostsuffix}"
# doesn't work due to PR33857, so an un-suffixed gnatmake has to be
# available
mkdir -p host-tools/bin
cp -a /usr/bin/gnatmake%{hostsuffix} host-tools/bin/gnatmake
cp -a /usr/bin/gnatlink%{hostsuffix} host-tools/bin/gnatlink
cp -a /usr/bin/gnatbind%{hostsuffix} host-tools/bin/gnatbind
cp -a /usr/bin/gcc%{hostsuffix} host-tools/bin/gcc
ln -sf /usr/%{_lib} host-tools/%{_lib}
export PATH="`pwd`/host-tools/bin:$PATH"
%endif
#%if 0%{?gcc_target_arch:1}
#%else
#	--enable-threads=posix \
#%endif
#	--enable-shared \
%if "%{TARGET_ARCH}" == "armv7hl"
# temporary workaround for a miscompilation of hash functions in java code
GCJ_EXTRA_FLAGS="-marm"
%endif
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" GCJFLAGS="$RPM_OPT_FLAGS $GCJ_EXTRA_FLAGS" \
../configure \
	--prefix=%{_prefix} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--enable-languages=$languages \
	$ENABLE_CHECKING \
	--with-gxx-include-dir=%{_prefix}/include/c++/%{gcc_dir_version} \
	--enable-ssp \
	--disable-libssp \
%if 0%{!?build_libvtv:1}
	--disable-libvtv \
%endif
%ifarch %mpx_arch
	--enable-libmpx \
%endif
	--disable-plugin \
	--with-bugurl="http://bugs.opensuse.org/" \
	--with-pkgversion="SUSE Linux" \
%if !%{build_libjava}
        --disable-libgcj \
%else
	--with-java-home=%{_libdir}/jvm/java-1.5.0-gcj%{binsuffix}-1.5.0.0/jre \
	--with-ecj-jar=%{libsubdir}/ecj.jar \
        --disable-java-awt \
%if !%{biarch_libjava}
        --disable-libjava-multilib \
%endif
%endif
	--with-slibdir=/%{_lib} \
	--with-system-zlib \
	--enable-__cxa_atexit \
	--enable-libstdcxx-allocator=new \
	--disable-libstdcxx-pch \
%if 0%{suse_version} <= 1320
	--with-default-libstdcxx-abi=gcc4-compatible \
%endif
	--enable-version-specific-runtime-libs \
%if 0%{suse_version} > 1100
	--enable-linker-build-id \
%endif
	--enable-linux-futex \
	--program-suffix=%{binsuffix} \
%if 0%{!?gcc_target_arch:1}
%ifarch ia64
	--with-system-libunwind \
%else
	--without-system-libunwind \
%endif
%endif
%if 0%{?gcc_target_arch:1}
	--program-prefix=%{gcc_target_arch}- \
	--target=%{gcc_target_arch} \
	--disable-nls \
%if 0%{?sysroot:1}
	--with-sysroot=%sysroot \
%else
	--with-sysroot=%{_prefix}/%{gcc_target_arch} \
%endif
%if 0%{?build_sysroot:1}
	--with-build-sysroot=%{build_sysroot} \
%else
%if 0%{?sysroot:1}
	--with-build-sysroot=%{sysroot} \
%else
	--with-build-sysroot=%{_prefix}/%{gcc_target_arch} \
%endif
%endif
%if 0%{?binutils_os:1}
	--with-build-time-tools=/usr/%{binutils_os}/bin \
%endif
%if "%{TARGET_ARCH}" == "spu"
	--with-gxx-include-dir=%sysroot/include/c++/%{gcc_dir_version} \
	--with-newlib \
%endif
%endif
%if "%{TARGET_ARCH}" == "armv5tel"
	--with-arch=armv5te \
	--with-float=soft \
	--with-mode=arm \
	--with-abi=aapcs-linux \
	--disable-sjlj-exceptions \
%endif
%if "%{TARGET_ARCH}" == "armv6hl"
        --with-arch=armv6zk \
        --with-tune=arm1176jzf-s \
        --with-float=hard \
        --with-abi=aapcs-linux \
        --with-fpu=vfp \
        --disable-sjlj-exceptions \
%endif
%if "%{TARGET_ARCH}" == "armv7hl"
	--with-arch=armv7-a \
	--with-tune=cortex-a15 \
	--with-float=hard \
	--with-abi=aapcs-linux \
	--with-fpu=vfpv3-d16 \
	--disable-sjlj-exceptions \
%endif
%if "%{TARGET_ARCH}" == "powerpc" || "%{TARGET_ARCH}" == "powerpc64" || "%{TARGET_ARCH}" == "powerpc64le"
%if "%{TARGET_ARCH}" == "powerpc"
        --with-cpu=default32 \
%endif
%if "%{TARGET_ARCH}" == "powerpc64le"
%if %{suse_version} >= 1315 && %{suse_version} != 1320
	--with-cpu=power8 \
	--with-tune=power8 \
%else
	--with-cpu=power7 \
	--with-tune=power7 \
%endif
%else
	--with-cpu-64=power4 \
%endif
	--enable-secureplt \
	--with-long-double-128 \
%if "%{TARGET_ARCH}" == "powerpc64le"
	--enable-targets=powerpcle-linux \
	--disable-multilib \
%endif
%endif
%if "%{TARGET_ARCH}" == "sparc64"
	--with-cpu=ultrasparc \
	--with-long-double-128 \
%endif
%if "%{TARGET_ARCH}" == "sparc"
	--with-cpu=v8 \
	--with-long-double-128 \
%endif
%if "%{TARGET_ARCH}" == "i586"
	--with-arch-32=i586 \
	--with-tune=generic \
%endif
%if "%{TARGET_ARCH}" == "x86_64"
	--enable-multilib \
	--with-arch-32=x86-64 \
	--with-tune=generic \
%endif
%if "%{TARGET_ARCH}" == "s390"
%if %{suse_version} >= 1310
        --with-tune=zEC12 --with-arch=z196 \
%else
	--with-tune=z9-109 --with-arch=z900 \
%endif
	--with-long-double-128 \
	--enable-decimal-float \
%endif
%if "%{TARGET_ARCH}" == "s390x"
%if %{suse_version} >= 1310
        --with-tune=zEC12 --with-arch=z196 \
%else
	--with-tune=z9-109 --with-arch=z900 \
%endif
	--with-long-double-128 \
	--enable-decimal-float \
%endif
%if "%{TARGET_ARCH}" == "m68k"
	--disable-multilib \
%endif
	--build=%{GCCDIST} \
	--host=%{GCCDIST}

%if 0%{?building_libffi:1}
make stage1-bubble $PARALLEL
make all-target-libffi $PARALLEL
%else
STAGE1_FLAGS="-g"
# Only run profiled bootstrap on archs where it works and matters
#%ifarch x86_64 ppc64le s390x
#make profiledbootstrap STAGE1_CFLAGS="$STAGE1_FLAGS" BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%else
make STAGE1_CFLAGS="$STAGE1_FLAGS" BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%endif
make info
%if 0%{?building_libjava:1}
make -C %{GCCDIST}/libstdc++-v3/doc doc-html-doxygen
%endif
%if 0%{?run_tests:1}
echo "Run testsuite"
(make -C %{GCCDIST}/libstdc++-v3 check-abi || true)
mv %{GCCDIST}/libstdc++-v3/testsuite/libstdc++.log %{GCCDIST}/libstdc++-v3/testsuite/libstdc++-abi.log
mv %{GCCDIST}/libstdc++-v3/testsuite/libstdc++.sum %{GCCDIST}/libstdc++-v3/testsuite/libstdc++-abi.sum
# asan needs a whole shadow address space
ulimit -v unlimited || true
make -k check $PARALLEL || true
mkdir ../testresults
../contrib/test_summary | tee ../testresults/test_summary.txt
%endif
%endif

%install
export NO_BRP_CHECK_BYTECODE_VERSION=true
cd obj-%{GCCDIST}
%if 0%{?run_tests:1} 
cp `find . -name "*.sum"` ../testresults/
cp `find . -name "*.log"  \! -name "config.log" | grep -v 'acats.\?/tests' ` ../testresults/
chmod 644 ../testresults/*
%endif

%if 0%{?run_tests:1}
%files 
%defattr(-,root,root)
%doc testresults/test_summary.txt
%doc testresults/*.sum
%doc testresults/*.log
%endif

%changelog
* Thu Jun  8 2017 rguenther@suse.com
- Bump libffi version in libffi.pc to 3.99999.  [bnc#1043580]
* Mon Mar  7 2016 rguenther@suse.com
- Update to gcc-5-branch head (r233831).
  * Includes fixes for [bnc#966220], [bnc#962765] and [bnc#964468].
- Add gcc5-aarch64-libffi.patch to revert accidential libffi ABI
  breakage on AARCH64.  [bnc#968771]
* Mon Dec  7 2015 rguenther@suse.com
- Update to GCC 5.3.1 (r231346).
  * Includes GCC 5.3 release with many bugfixes.
- Drop cloog-isl build dependency from cross packages.
* Fri Nov 20 2015 rguenther@suse.com
- Update to gcc-5-branch head (r230656).
  * Includes fix for HTM builtins on powerpc.  [bnc#955382]
  * Includes fix for build with ISL 0.15.
* Mon Nov  9 2015 rguenther@suse.com
- For x86_64 default 32bit code generation to -march=x86-64 rather
  than -march=i586.
- Fix libgo certificate lookup, adds gcc5-libgo-fix-certificates-lookup.patch.
  [bsc#953831]
- Build s390[x] with --with-tune=z9-109 --with-arch=z900 on SLE11
  again.  [bnc#954002]
* Thu Oct  8 2015 rguenther@suse.com
- Update to gcc-5-branch head (r228589).
  * Includes fix for [bnc#939460].
  * Includes fix for C++11 std::random_device short reads, CVE-2015-5276.
    [bnc#945842]
  * Experimental File System TS library.
- For non-icecream cross-compilers %%sysroot is always defined,
  so any conditionalization can be dropped as cleanup.
* Fri Sep 18 2015 dvaleev@suse.com
- Optimize ppc64le for power8 on Tumbleweed
* Tue Jul 21 2015 meissner@suse.com
- filter out -fstack-protector-strong too
* Tue Jul 21 2015 rguenther@suse.com
- Update to gcc-5-branch head (r226025).
  * Includes GCC 5.2 release
  * Includes post-release fix for Wine.
* Tue Jul 14 2015 rguenther@suse.com
- Allow for %%{binutils_target} containing dashes by quoting in %%if.
- Postpone docs cleanup beyond target installation.
- Assure files in %%{_bindir} have the expected prefix.
* Mon Jul 13 2015 rguenther@suse.com
- Update to gcc-5-branch head (r225724).
  * Includes GCC 5.2 RC2
- Adjust .changes file generation for optional compiler build.
* Tue Jul  7 2015 rguenther@suse.com
- Update to gcc-5-branch head (r225500).
  * Includes GCC 5.2 RC1
- Pack s390[x] vecintrin.h file.
- Adjust optional compiler setup to also build Ada and Go and keep
  separate spec files for libffi and the testsuite.
* Tue Jun 30 2015 schwab@suse.de
- Add cross-m68k-gcc5
* Wed Jun 24 2015 matz@suse.com
- Remove include-fixed/linux/vt.h as well.
* Mon Jun 22 2015 rguenther@suse.com
- Update to gcc-5-branch head (r224716).
- Fix libffi include install.  [bnc#935510]
- Package new mwaitxintrin.h file.
* Tue Jun  9 2015 rguenther@suse.com
- Update to gcc-5-branch head (r224257).
* Mon Jun  8 2015 rguenther@suse.com
- Fix build against SLE11 SP4.
  * Where mpfr 2.4.0 is not available disable the few features
    requiring it to allow building with mpfr 2.3.2,
    gcc48-remove-mpfr-2.4.0-requirement.patch.
  * Disable building the MPX library.
  * Re-instantiate IA64 support.
  * Add gcc5-no-return-gcc43-workaround.patch to avoid bogus warnings
    from the GCC 4.3 host compiler.
* Mon May 18 2015 rguenther@suse.com
- Update to gcc-5-branch head (r223279).
  * Includes fix for [bnc#930496] and [bnc#930392].
- Enable 32bit code generation for ppc64le but do not build 32bit
  target libraries.  Fixes ppc64le kernel compile.
* Fri May  8 2015 rguenther@suse.com
- Update to gcc-5-branch head (r222900).
- Add proper dependences to -32bit/-64bit compiler variants.  Add
  gcc5-c++-32/64bit and gcc5-obj-c++-32/64bit (for their dependencies
  only).
- Rename libstdc++5-devel to libstdc++6-devel-gcc5 following shared
  library suffixing (but applying always).
- Likewise for libgcj devel and jar packages and for libffi.
- Renames libgcj and libffi spec files.
* Mon Apr 27 2015 rguenther@suse.com
- Update to gcc-5-branch head (r222451).
  * Includes GCC 5.1.0 release and first chunk of bugfixes and powerpc
    backports.
- Enable building libmpx for i586 and x86_64.
* Mon Apr 20 2015 rguenther@suse.com
- Update to gcc-5-branch head (r222226).
  * Includes GCC 5.1 RC2.
* Thu Apr 16 2015 rguenther@suse.com
- Update to gcc-5-branch head (r222139).
* Mon Apr 13 2015 rguenther@suse.com
- Update to gcc-5-branch head (r222032).
  * Matches GCC 5.1 RC1.
* Thu Apr  9 2015 rguenther@suse.com
- Update to SVN trunk head (r221942).
* Tue Apr  7 2015 afaerber@suse.de
- Prepare for non-icecream cross-compilers
  * Define sysroot to match cross-binutils config
  * Prepare for requiring cross-newlib for some targets
  * Use all-host target for libc bootstrap, too
  * Install target files, but suppress stripping them (breaks them)
  * Suppress -icecream-backend subpackage
  * Allow building on any architecture
* Tue Apr  7 2015 rguenther@suse.com
- Update to SVN trunk head (r221888).
- Enable cross compiler builds.
* Thu Apr  2 2015 schwab@suse.de
- libsanitizer-tsan-res-state.patch: remove obsolete patch.
- gcc5-libsanitize-aarch64-va42.patch: support aarch64 42-bit address
- space
* Tue Mar 24 2015 rguenther@suse.com
- Update to SVN trunk head (r221624).
- Require own ada version for suse_version > 1330, not explicitely
  gcc49-ada.
- Amend _constraints to request more physical memory for gcc5 and
  gcc5-testresults as well as 4 processors for gcc5.
* Thu Mar 19 2015 rguenther@suse.com
- Update to SVN trunk head (r221515).
* Wed Mar 18 2015 rguenther@suse.com
- Update to SVN trunk head (r221482).
  * Fixes miscompile of vim.
* Tue Mar 10 2015 rguenther@suse.com
- Update to SVN trunk head (r221322).
  * Contains fixes for PR65120 and should reduce the amount of
    false -Wlogical-not-parentheses warnings.
- Switch to release checking builds.
* Tue Mar  3 2015 rguenther@suse.com
- Update to SVN trunk head (r221139).
  * Includes gcc5-pr65040.patch which is now removed.
- Add libsanitizer-tsan-res-state.patch to fix build with new glibc.
- Enable asan and ubsan for ppc64le.
* Fri Feb 27 2015 rguenther@suse.com
- Add gcc5-pr65040.patch to remove -Wformat-signedness from -Wformat=2.
- Renumber patches.
* Wed Feb 25 2015 rguenther@suse.com
- Update to SVN trunk head (r220959).
* Fri Feb 20 2015 rguenther@suse.com
- Update to SVN trunk head (r220833).
* Tue Feb 17 2015 rguenther@suse.com
- Update to SVN trunk head (r220758).
* Fri Feb 13 2015 rguenther@suse.com
- Update to SVN trunk head (r220678).
* Wed Feb 11 2015 rguenther@suse.com
- Update to SVN trunk head (r220617).
* Tue Feb 10 2015 rguenther@suse.com
- Update to SVN trunk head (r220580).
- Pulls bugfixing from Fedora mass-rebuild.
* Wed Jan 28 2015 rguenther@suse.com
- Update to SVN trunk head (r220205).
- Strip GO binaries again.
* Fri Jan 23 2015 rguenther@suse.com
- Update to SVN trunk head (r220030).
- Package go and gofmt manpages.
* Thu Jan 22 2015 rguenther@suse.com
- Update to SVN trunk head (r219990).
- Make sure to not strip GO binaries as that makes them fail to run.
- Bump libgcj SO version.
* Tue Jan 20 2015 rguenther@suse.com
- Update to SVN trunk head (r219892).
- Do not remove fixed includes for non-icecream like built crosses.
- Use the C++98 libstdc++ ABI by default on openSUSE 13.2 and older.
* Thu Jan 15 2015 rguenther@suse.com
- Update to SVN trunk head (r219634).
- Bump libgo SO version.
* Tue Jan 13 2015 rguenther@suse.com
- Update to SVN trunk head (r219531).
- Update gcc-dir-version.patch with upstream libgcj.pc file name changes.
* Mon Dec 15 2014 rguenther@suse.com
- Update to SVN trunk head (r218749).
- Drop gcc5-pr61558.patch.
* Fri Dec 12 2014 rguenther@suse.com
- Update to SVN trunk head (r218668).
- Enable GRAPHITE everywhere.
- Add gcc5-pr61558.patch to help identifying that issue easier.
* Wed Dec 10 2014 rguenther@suse.com
- Update to SVN trunk head (r218580).
* Tue Dec  2 2014 rguenther@suse.com
- Update to SVN trunk head (r218267).
  * Obsoletes gcc5-libsanitizer-fix.diff and gcc5-fix-gnatvsn.patch
* Fri Nov 21 2014 rguenther@suse.com
- Add gcc5-libsanitizer-fix.diff to fix bug in libsanitizer that
  prevents build on aarch64.
* Tue Nov 18 2014 rguenther@suse.com
- Update to SVN trunk head (r217714).
  * should fix non-%%x86 build.
* Mon Nov 17 2014 rguenther@suse.com
- New package, inherits from gcc49
  * gcc-dir-version.patch, drop patchlevel from install directory names
  * gcc-add-defaultsspec.diff, add the ability to provide a specs file
  that is read by default
  * Wunprototyped-calls.diff, new warning to warn about calls to functions
  without seeing a real prototype earlier
  * libjava-no-multilib.diff, do not build multilibs for libjava even on
  multilib systems (we use baselibs for it)
  * tls-no-direct.diff, avoid direct %%fs references on x86 to not slow down
  Xen
  * gcc43-no-unwind-tables.diff, do not produce unwind tables for CRT files
  * gcc41-java-slow_pthread_self.patch, force us to assume pthread_self
  is fast
  * gcc41-ppc32-retaddr.patch, fix expansion of __builtin_return_addr for ppc
  * gcc44-textdomain.patch, make translation files version specific and
  adjust textdomain to find them
  * gcc44-rename-info-files.patch, fix cross-references in info files when
  renaming them to be version specific
  * gcc48-libstdc++-api-reference.patch, fix link in the installed libstdc++
  html documentation
- Adds the following patches
  * gcc5-fix-gnatvsn.patch, fix PR63931
- Drops IA64 support.
